Add diskdump support in create (part 2)
[snf-image] / snf-image-host / create
1 #!/bin/bash
2
3 # Copyright 2011 GRNET S.A. All rights reserved.
4 #
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions
7 # are met:
8 #
9 #   1. Redistributions of source code must retain the above copyright
10 #      notice, this list of conditions and the following disclaimer.
11 #
12 #  2. Redistributions in binary form must reproduce the above copyright
13 #     notice, this list of conditions and the following disclaimer in the
14 #     documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
17 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19 # ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
20 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26 # SUCH DAMAGE.
27 #
28 # The views and conclusions contained in the software and documentation are
29 # those of the authors and should not be interpreted as representing official
30 # policies, either expressed or implied, of GRNET S.A.
31
32 set -e
33 set -o pipefail
34
35 . common.sh
36
37 ganeti_os_main
38
39 image_file="$IMAGE_DIR/$IMAGE_NAME-$ARCH.$IMAGE_TYPE"
40
41 if [ ! -e "$image_file" ]; then
42     log_error "Image file \`$image_file' does not exit."
43     exit 1
44 fi
45
46 monitor="" #Empty if progress monitor support is disabled
47 if [ "$progress_monitor_support" = "yes" ]; then
48     image_size="$(stat -L -c %s "$image_file")"
49     monitor="$(printf "%q" "$PROGRESS_MONITOR") \
50         -i $(printf "%q" "$INSTANCE_NAME") -r $image_size"
51 fi
52
53 # If the target device is not a real block device we'll first losetup it.
54 # This is needed for file disks.
55 if [ ! -b "$blockdev" ]; then
56     original_blockdev="$blockdev"
57     blockdev=$("$LOSETUP" -sf "$blockdev")
58     add_cleanup "$LOSETUP" -d "$blockdev"
59 fi
60
61 case "$IMAGE_TYPE" in
62     ntfsdump, extdump)
63         # Create partitions
64         format_disk0 "$blockdev" "$IMAGE_TYPE"
65
66         # Install a new MBR
67         "$INSTALL_MBR" -p 1 -i n "$blockdev"
68
69         target="$(map_disk0 "$blockdev")-1" #the root device
70         add_cleanup unmap_disk0 "$blockdev"
71         ;;
72     diskdump)
73         target="$blockdev"
74         ;;
75 esac
76
77 # dd the dump to its new home :-)
78 # Deploying an image file on a target block device is a streaming copy
79 # operation. Enable the direct I/O flag on the output fd to avoid polluting the
80 # host cache with useless data.
81 $monitor dd bs=4M if="$image_file" of="$target" oflag=direct
82
83 # Create a floppy image
84 floppy=$(mktemp --tmpdir floppy.XXXXXX)
85 add_cleanup rm "$floppy"
86
87 snf_export_DEV=/dev/vda
88 snf_export_TYPE="$IMG_FORMAT"
89 snf_export_PASSWORD="$IMG_PASSWD"
90 snf_export_HOSTNAME="$instance"
91 if [ -n "$IMG_PERSONALITY" ]; then
92     snf_export_PERSONALITY="$IMG_PERSONALITY"
93 fi
94
95 create_floppy "$floppy"
96
97 # Invoke the helper vm to do the dirty job...
98 result_file=$(mktemp --tmpdir result.XXXXXX)
99 add_cleanup rm "$result_file"
100
101 snapshot=$(mktemp --tmpdir helperXXXXXX.img)
102 add_cleanup rm "$snapshot"
103
104 "$QEMU_IMG" create -f qcow2 -b "$HELPER_IMG" "$snapshot"
105
106 echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Starting helper VM..."
107 "$TIMELIMIT" -t "$HELPER_SOFT_TIMEOUT" -T "$HELPER_HARD_TIMEOUT" \
108     kvm -runas "$HELPER_USER" -drive file="$snapshot" \
109     -drive file="$blockdev",format=raw,if=virtio,cache=none \
110     -boot c -serial stdio -serial file:"$result_file" \
111     -fda "$floppy" -vga none -nographic -parallel none -monitor null \
112     -kernel "$HELPER_KERNEL" -initrd "$HELPER_INITRD" \
113     -append "quiet ro root=/dev/sda1 console=ttyS0,9600n8 snf_image_activate_helper" \
114     2>&1 | sed 's|^|HELPER: |g'
115 echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Helper VM finished."
116
117 if [ $? -ne 0 ]; then
118     if [ $? -gt 128 ];  then
119         log_error "Helper was terminated. Did not finish on time."
120     fi
121     exit 1
122 fi
123
124 # Read the first line. This will remove \r and \n chars
125 result=$(sed 's|\r||g' "$result_file" | head -1)
126
127 if [ "x$result" != "xSUCCESS" ]; then
128     log_error "Helper VM returned error"
129     exit 1
130 fi
131
132 # Execute cleanups
133 cleanup
134 trap - EXIT
135
136 exit 0
137
138 # vim: set sta sts=4 shiftwidth=4 sw=4 et ai :